
//	This source and fast ascii text file search method apply to GNU General Public License. 
//			Copyright (C) 2006,2007,2008,2009,2010 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			ASCII Text File Search Routine
//			written by Dzinleski Jasenko November,2006 and later
//


#include <stdio.h>
#include <string.h>

#define		lcl		1000000
#define		bfl		7000
#define		cl		100

FILE		*f1;
char		infn[255]="war_and_peace_nt.txt";

int		fb[bfl];
int		fbi;
int		fbt[bfl];
int		fbti;

int		ws[10][cl];
int		wsl[10];
int		wsi=0;

int		ba16[16][16][16][16][2];

int		pos[1000][bfl];
int		posi=0;

int		pos1[bfl];

long		linec[lcl][2];
int		lineci=0;
int		hits[lcl];

int		pmatch;
int		occ=0;

char		c_l[256]="{[--]}{[hh][ll][ee][ss]}{[AZ][az][09][__][  ][..][\'\'][\"\"][++]}{[--]}{[ff]}{[AZ][az][09][__][  ][..][\'\'][\"\"][++]}{[--]}";

int	c_p(char cl_a[256],int ci,bool tf,char r_a[256])
{

	int		a,b,c,d=0;
	
	for(a=0;a<256;++a){r_a[a]='\0';}

	if(tf)
	{
		for(a=0;a<strlen(c_l);++a){
			if(cl_a[a]=='{'){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]=='}'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}else{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='['){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]==']'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}

	d=0;for(c=a+1;c<b;++c){r_a[d]=cl_a[c];++d;/*printf("%c",cl_a[c]);*/}

	return(0);

}

int hc113(int spos,int sline,int eline,int ind)
{
	int		i,j,k,l,m,n;
	int		a,b;
	char		sl[255];

	for(i=0;i<bfl;++i){pos1[i]=-1;}
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l)
	{
		ba16[i][j][k][l][0]=-1;
		ba16[i][j][k][l][1]=0;
	}}}}	

	posi=0;
	for(i=spos;i<=bfl;++i)
	{
		if(ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]==-1)
		{
			ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]=posi;		
			pos[posi][ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];	
			++posi;
		}else{
			pos[ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]][ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];				
		}

		++i;

		if(ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]==-1)
		{
			ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]=posi;		
			pos[posi][ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];	
			++posi;
		}else{
			pos[ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][0]][ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1]]=i;
			++ba16[(fb[i]&0x00f0)>>4][fb[i]&0x000f][(fb[i+1]&0x00f0)>>4][fb[i+1]&0x000f][1];				
		}
	}

	for(i=0;i<=wsl[ind];++i)
	{
		if(ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]==-1){}else{

			if(i==0)
			{

				for(k=ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][1]-1;k>=0;--k)
				{
					j=pos[ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]][k];
					pos1[j]=1;
				}

			}else{

				for(k=ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][1]-1;k>=0;--k)
				{
					j=pos[ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]][k];
					if(j-i>=0&&pos1[j-i]!=-1){}
				}

				++i;

				for(k=ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][1]-1;k>=0;--k)
				{
					j=pos[ba16[(ws[ind][i]&0x00f0)>>4][ws[ind][i]&0x000f][(ws[ind][i+1]&0x00f0)>>4][ws[ind][i+1]&0x000f][0]][k];
					if(j-i>=0&&pos1[j-i]!=-1){}else{pos1[j]=-1;}
				}
			}
		}
	}

	if(pmatch==0)
	{
		for(i=0;i<bfl;++i)
		{
			if(pos1[i]!=-1)
			{
				for(l=sline;l<eline;++l)
				{
					if(i>=linec[l][0]&&i<=linec[l][1])
					{
						++hits[l];break;	
					}
				}
			}
		}
	}

	if(pmatch==1)
	{
		for(i=0;i<bfl;++i)
		{
			if(pos1[i]!=-1)
			{
				for(l=sline;l<eline;++l)
				{
					if(i>=linec[l][0]&&i<=linec[l][1])
					{
						for(n=0;n<255;++n){sl[n]='\0';}
						n=0;for(m=linec[l][0];m<linec[l][1];++m){sl[n]=fb[m];++n;}
						for(m=0;m<strlen(sl);++m)
						{
							for(n=0;n<wsl[ind];++n)
							{
								if(ws[ind][n]!=sl[m+n]){break;}
							}
							if(n==wsl[ind]){++hits[l];break;}
						}
							
					}
				}
			}
		}
	}

	return(0);	

}

long hc11(long spos)
{

	int		i,j,l,m;
	int		a,b,c;
	int		fbyte;
	long		rpos;

	for(i=0;i<bfl;++i){fb[i]=0;fbt[i]=0;}

	f1=fopen(infn,"rb");if(spos==0){}else{fseek(f1,spos,SEEK_SET);}

	fbi=0;fbti=0;fbyte=0;a=lineci;fbyte=getc(f1);

	while(!feof(f1)&&fbi+fbti<bfl)
	{
		fbt[fbti]=fbyte;++fbti;
		fbyte=getc(f1);
		if(fbyte==13||fbyte==10)
		{
			fbt[fbti]=fbyte;++fbti;c=1;
			while(fbyte==13||fbyte==10){if(fbt[-1+fbti]==(fbyte=getc(f1))){++lineci;}}
			if(fbi+fbti<bfl)
			{
				linec[lineci][0]=fbi;
				for(i=0;i<fbti-c;++i){fb[fbi]=fbt[i];++fbi;}linec[lineci][1]=fbi;++lineci;
				for(i=0;i<bfl;++i){fbt[i]=0;}fbti=0;rpos=ftell(f1);
			}
			//printf(" %d ",-1+lineci);for(m=linec[-1+lineci][0];m<linec[-1+lineci][1];++m){printf("%c",fb[m]);}printf("\n");
		}
	}
	if(feof(f1)){rpos=-1;}fclose(f1);b=-1+lineci;

	for(j=0;j<lcl;++j){hits[j]=0;}for(i=0;i<wsi;++i){hc113(0,a,b,i);}
	for(j=a;j<=b;++j)
	{
		if(hits[j]!=0)
		{
			printf("Line# %d--> ",j);for(m=linec[j][0];m<linec[j][1];++m){printf("%c",fb[m]);}printf("\n");
			++occ;
		}
	}

	return(rpos);

}

int main(int argc,char *argv[])
{

	int		a,b,c,ci,d;
	int		i,j,k,l,m;

	char		cmd[50][256];
	char		c_1[256];
	char		c_2[256];

	char		fn[10][2];int	fi=0;
	int		op=0;
	long		pos=0;
	char		ss[cl];
	int		cc=0;

	for(i=0;i<50;++i){for(j=0;j<256;++j){cmd[i][j]='\0';}}
	for(i=0;i<argc;++i){strcpy(cmd[i],argv[i]);}

	for(i=0;i<lcl;++i){linec[i][0]=-1;linec[i][1]=-1;}

	printf("\nASCII Text File Search Routine\n");
	printf("written by Dzinleski Jasenko November,2006 and later\n");
	printf("\nOS Win32 VRM 1.4.1\n\n");

	//|	-
	ci=1;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][0]==c_2[0]||cmd[1][0]==c_2[1]){}else{return(0);}
	//|

	//|	h, l , e , s 
	ci=2;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=1;/*printf("h");*/}

	ci=2;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=2;/*printf("l");*/}

	ci=3;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=3;/*printf("e");*/}

	ci=4;
	for(i=0;i<256;++i){c_2[i]='\0';}
	c_p(c_1,ci,false,c_2);
	//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

	if(cmd[1][1]==c_2[0]||cmd[1][1]==c_2[1]){op=4;/*printf("s");*/}

	if(!(op==1||op==2||op==3||op==4)){return(0);}else{


 		if(op==1)
		{

			//printf("\nASCII Text File Search Routine\n");
			//printf("written by Dzinleski Jasenko November,2006 and later\n");
			//printf("\nOS Win32 VRM 1.4.1\n\n");
			//printf("\n");
			printf("msearch -s(-e) <search string 1>+...+<search string 10> -f <filename to search>\n");
			printf("\n");

			return(0);

		}


		if(op==2)
		{

			//printf("\nASCII Text File Search Routine\n");
			//printf("written by Dzinleski Jasenko November,2006\n");
			//printf("\nOS Win32 VRM 1.4.1\n\n");
			//printf("\n");

			printf("\tThis source and fast ascii text file search method apply to GNU General Public License.\n");
			printf("\t		Copyright (C) 2006,2007,2008,2009,2010 Jasenko Dzinleski \n");
			printf("\n");
			printf("\t	This program is free software; you can redistribute it\n");
			printf("\tand/or modify it under the terms of the GNU General Public License as\n");
			printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
			printf("\tLicense, or (at your option) any later version.\n");
			printf("\n");
			printf("\tThis program is distributed in the hope that it will be useful, but\n");
			printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
			printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
			printf("\tGeneral Public License for more details.\n");
			printf("\n");
			printf("\tYou should have received a copy of the GNU General Public License along\n");
			printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
			printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
			printf("\n"); 			return(0);

		}


		if(op==3)
		{

		//|	<filename>
		ci=3;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=2;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=3;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=4;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=5;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=6;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|

		ci=7;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|

		ci=8;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|

		ci=9;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|

		for(i=0;i<strlen(cmd[2]);++i)
		{
			if
				(
				(cmd[2][i]>=fn[0][0]&&cmd[2][i]<=fn[0][1])||
				(cmd[2][i]>=fn[1][0]&&cmd[2][i]<=fn[1][1])||
				(cmd[2][i]>=fn[2][0]&&cmd[2][i]<=fn[2][1])||
				(cmd[2][i]>=fn[3][0]&&cmd[2][i]<=fn[3][1])||
				(cmd[2][i]>=fn[4][0]&&cmd[2][i]<=fn[4][1])||
				(cmd[2][i]>=fn[5][0]&&cmd[2][i]<=fn[5][1])||
				(cmd[2][i]>=fn[6][0]&&cmd[2][i]<=fn[6][1])||
				(cmd[2][i]>=fn[7][0]&&cmd[2][i]<=fn[7][1])||
				(cmd[2][i]>=fn[8][0]&&cmd[2][i]<=fn[8][1])
				){}else{break;}
		}
		if(i==strlen(cmd[2])){/*printf("?");*/}else{return(0);}
		//|

		pmatch=1;
		for(j=0;j<cl;++j){ss[j]='\0';}
		strcpy(ss,cmd[2]);
		k=0;
		for(j=0;j<strlen(ss);++j){if(ss[j]=='+'){++cc;}}						

		l=0;m=0;
		while(l<=cc)
		{
			for(j=0;j<cl;++j){ws[l][j]='\0';}
			for(j=m;j<strlen(ss)&&ss[j]!='+';++j)
			{
				ws[l][j-m]=ss[j];
			}
			wsl[l]=j-m;
			for(j=0;j<wsl[l];++j){printf("%c",ws[l][j]);}printf(" ");//printf("%d",wsl[l]);
			++l;m+=j+1;++wsi;
		}
		printf("\n");

		//|	-
		ci=4;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		if(cmd[3][0]==c_2[0]||cmd[3][0]==c_2[1]){}else{return(0);}
		//|
	
		//|	f 
		ci=5;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}
	
		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}
	
		if(cmd[3][1]==c_2[0]||cmd[3][1]==c_2[1])
		{
	
			for(j=0;j<50;++j){infn[j]='\0';}
			strcpy(infn,cmd[4]);
	
			f1=fopen(infn,"rb");
			if(f1!=NULL)
			{
				fclose(f1);
	
				//printf(" %s %d",infn,ws[ind]);
				//printf(" %s %s %d",infn,ws[1],wsi[1]);
				//printf(" %s %s %d",infn,ws[2],wsi[2]);
	
				while(pos!=-1){pos=hc11(pos);}
	
				printf("\n\nTotal occurences found:%d",occ);
				printf("\nOk");
			}
	
		}

		}


		if(op==4)
		{

		//|	<filename>
		ci=3;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=2;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=3;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=4;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=5;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;

		ci=6;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|

		ci=7;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|

		ci=8;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|

		ci=9;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
		//|


		for(i=0;i<strlen(cmd[2]);++i)
		{
			if
				(
				(cmd[2][i]>=fn[0][0]&&cmd[2][i]<=fn[0][1])||
				(cmd[2][i]>=fn[1][0]&&cmd[2][i]<=fn[1][1])||
				(cmd[2][i]>=fn[2][0]&&cmd[2][i]<=fn[2][1])||
				(cmd[2][i]>=fn[3][0]&&cmd[2][i]<=fn[3][1])||
				(cmd[2][i]>=fn[4][0]&&cmd[2][i]<=fn[4][1])||
				(cmd[2][i]>=fn[5][0]&&cmd[2][i]<=fn[5][1])||
				(cmd[2][i]>=fn[6][0]&&cmd[2][i]<=fn[6][1])||
				(cmd[2][i]>=fn[7][0]&&cmd[2][i]<=fn[7][1])||
				(cmd[2][i]>=fn[8][0]&&cmd[2][i]<=fn[8][1])
				){}else{break;}
		}
		if(i==strlen(cmd[2])){/*printf("?");*/}else{return(0);}
		//|

		pmatch=0;
		for(j=0;j<cl;++j){ss[j]='\0';}
		strcpy(ss,cmd[2]);
		k=0;
		for(j=0;j<strlen(ss);++j){if(ss[j]=='+'){++cc;}}						

		l=0;m=0;
		while(l<=cc)
		{
			for(j=0;j<cl;++j){ws[l][j]='\0';}
			for(j=m;j<strlen(ss)&&ss[j]!='+';++j)
			{
				ws[l][j-m]=ss[j];
			}
			wsl[l]=j-m;
			for(j=0;j<wsl[l];++j){printf("%c",ws[l][j]);}printf(" ");//printf("%d",wsl[l]);
			++l;m+=j+1;++wsi;
		}
		printf("\n");

		//|	-
		ci=4;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}

		if(cmd[3][0]==c_2[0]||cmd[3][0]==c_2[1]){}else{return(0);}
		//|
	
		//|	f 
		ci=5;
		for(i=0;i<256;++i){c_1[i]='\0';}
		c_p(c_l,ci,true,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}
	
		ci=1;
		for(i=0;i<256;++i){c_2[i]='\0';}
		c_p(c_1,ci,false,c_2);
		//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}
	
		if(cmd[3][1]==c_2[0]||cmd[3][1]==c_2[1])
		{
	
			for(j=0;j<50;++j){infn[j]='\0';}
			strcpy(infn,cmd[4]);
	
			f1=fopen(infn,"rb");
			if(f1!=NULL)
			{
				fclose(f1);
	
				//printf(" %s %d",infn,ws[ind]);
				//printf(" %s %s %d",infn,ws[1],wsi[1]);
				//printf(" %s %s %d",infn,ws[2],wsi[2]);
	
				while(pos!=-1){pos=hc11(pos);}
	
				printf("\n\nTotal occurences found:%d",occ);
				printf("\nOk");
			}
	
		}

		}

	}
	//|
	
	return(0);

}

